(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Require Import Why.

Parameter F : Z -> Z.
Axiom F_0 : F 0 = 1%Z.
Axiom F_1 : F 1 = 1%Z.
Axiom F_n : forall n:Z, (n >= 2)%Z -> F n = (F (n - 1) + F (n - 2))%Z.
Hint Resolve F_0 F_1 F_n .

(* Why obligation from file "fib.mlw", characters 447-448 *)
Lemma fib1_po_1 : 
  forall (n: Z),
  forall (Pre12: n >= 0),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (Pre11: Variant1 = n0),
  forall (Pre10: n0 >= 0),
  forall (Test2: n0 <= 1),
  1 = (F n0).
Proof.
intros.
assert (n0 = 0%Z \/ n0 = 1%Z); intuition try (rewrite H0; auto with *).
omega.
Qed.

(* Why obligation from file "fib.mlw", characters 480-494 *)
Lemma fib1_po_2 : 
  forall (n: Z),
  forall (Pre12: n >= 0),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (Pre11: Variant1 = n0),
  forall (Pre10: n0 >= 0),
  forall (Test1: n0 > 1),
  (n0 - 2) >= 0.
Proof.
intros; omega.
Qed.

(* Why obligation from file "fib.mlw", characters 413-515 *)
Lemma fib1_po_3 : 
  forall (n: Z),
  forall (Pre12: n >= 0),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (Pre11: Variant1 = n0),
  forall (Pre10: n0 >= 0),
  forall (Test1: n0 > 1),
  forall (Pre9: (n0 - 2) >= 0),
  forall (Pre3: (n0 - 2) >= 0),
  forall (Pre4: (n0 - 2) >= 0),
  (Zwf 0 (n0 - 2) Variant1).
Proof.
intros; unfold Zwf; omega.
Qed.

(* Why obligation from file "fib.mlw", characters 463-477 *)
Lemma fib1_po_4 : 
  forall (n: Z),
  forall (Pre12: n >= 0),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (Pre11: Variant1 = n0),
  forall (Pre10: n0 >= 0),
  forall (Test1: n0 > 1),
  forall (Pre9: (n0 - 2) >= 0),
  forall (aux_6: Z),
  forall (Post4: aux_6 = (F (n0 - 2))),
  (n0 - 1) >= 0.
Proof.
intros; omega.
Qed.

(* Why obligation from file "fib.mlw", characters 413-515 *)
Lemma fib1_po_5 : 
  forall (n: Z),
  forall (Pre12: n >= 0),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (Pre11: Variant1 = n0),
  forall (Pre10: n0 >= 0),
  forall (Test1: n0 > 1),
  forall (Pre9: (n0 - 2) >= 0),
  forall (aux_6: Z),
  forall (Post4: aux_6 = (F (n0 - 2))),
  forall (Pre8: (n0 - 1) >= 0),
  forall (Pre6: (n0 - 1) >= 0),
  forall (Pre7: (n0 - 1) >= 0),
  (Zwf 0 (n0 - 1) Variant1).
Proof.
intros; unfold Zwf; omega.
Qed.

(* Why obligation from file "fib.mlw", characters 463-494 *)
Lemma fib1_po_6 : 
  forall (n: Z),
  forall (Pre12: n >= 0),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (Pre11: Variant1 = n0),
  forall (Pre10: n0 >= 0),
  forall (Test1: n0 > 1),
  forall (Pre9: (n0 - 2) >= 0),
  forall (aux_6: Z),
  forall (Post4: aux_6 = (F (n0 - 2))),
  forall (Pre8: (n0 - 1) >= 0),
  forall (aux_5: Z),
  forall (Post7: aux_5 = (F (n0 - 1))),
  (aux_5 + aux_6) = (F n0).
Proof.
intros.
subst aux_6 aux_5.
symmetry; auto with *.
Qed.


(* Why obligation from file "fib.mlw", characters 713-715 *)
Lemma fib2_aux_po_1 : 
  forall (n: Z),
  forall (x: Z),
  forall (fx: Z),
  forall (fx_1: Z),
  forall (Pre8: (1 <= x /\ x <= n) /\ fx = (F x) /\ fx_1 = (F (x - 1))),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (x0: Z),
  forall (fx0: Z),
  forall (fx_1_0: Z),
  forall (Pre7: Variant1 = (n0 - x0)),
  forall (Pre6: (1 <= x0 /\ x0 <= n0) /\ fx0 = (F x0) /\ fx_1_0 =
                (F (x0 - 1))),
  forall (Test2: x0 = n0),
  fx0 = (F n0).
Proof.
intuition.
rewrite <- Test2; assumption.
Qed.

(* Why obligation from file "fib.mlw", characters 731-762 *)
Lemma fib2_aux_po_2 : 
  forall (n: Z),
  forall (x: Z),
  forall (fx: Z),
  forall (fx_1: Z),
  forall (Pre8: (1 <= x /\ x <= n) /\ fx = (F x) /\ fx_1 = (F (x - 1))),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (x0: Z),
  forall (fx0: Z),
  forall (fx_1_0: Z),
  forall (Pre7: Variant1 = (n0 - x0)),
  forall (Pre6: (1 <= x0 /\ x0 <= n0) /\ fx0 = (F x0) /\ fx_1_0 =
                (F (x0 - 1))),
  forall (Test1: x0 <> n0),
  (1 <= (x0 + 1) /\ (x0 + 1) <= n0) /\ (fx0 + fx_1_0) = (F (x0 + 1)) /\ fx0 =
  (F (x0 + 1 - 1)).
Proof.
intuition.
subst fx0 fx_1_0; symmetry.
generalize H5.
 replace x0 with (x0 + 1 - 1)%Z.
 generalize (x0 + 1)%Z.
intros; ring (z - 1 + 1)%Z; replace (z - 1 - 1)%Z with (z - 2)%Z.
 auto with *.
omega.
omega.
ring (x0 + 1 - 1)%Z; trivial.
Qed.

(* Why obligation from file "fib.mlw", characters 643-783 *)
Lemma fib2_aux_po_3 : 
  forall (n: Z),
  forall (x: Z),
  forall (fx: Z),
  forall (fx_1: Z),
  forall (Pre8: (1 <= x /\ x <= n) /\ fx = (F x) /\ fx_1 = (F (x - 1))),
  forall (Variant1: Z),
  forall (n0: Z),
  forall (x0: Z),
  forall (fx0: Z),
  forall (fx_1_0: Z),
  forall (Pre7: Variant1 = (n0 - x0)),
  forall (Pre6: (1 <= x0 /\ x0 <= n0) /\ fx0 = (F x0) /\ fx_1_0 =
                (F (x0 - 1))),
  forall (Test1: x0 <> n0),
  forall (Pre5: (1 <= (x0 + 1) /\ (x0 + 1) <= n0) /\ (fx0 + fx_1_0) =
                (F (x0 + 1)) /\ fx0 = (F (x0 + 1 - 1))),
  forall (Pre3: (1 <= (x0 + 1) /\ (x0 + 1) <= n0) /\ (fx0 + fx_1_0) =
                (F (x0 + 1)) /\ fx0 = (F (x0 + 1 - 1))),
  forall (Pre4: (1 <= (x0 + 1) /\ (x0 + 1) <= n0) /\ (fx0 + fx_1_0) =
                (F (x0 + 1)) /\ fx0 = (F (x0 + 1 - 1))),
  (Zwf 0 (n0 - (x0 + 1)) Variant1).
Proof.
intuition.
Qed.


(* Why obligation from file "fib.mlw", characters 842-843 *)
Lemma fib2_po_1 : 
  forall (n: Z),
  forall (Pre4: n >= 0),
  forall (Test2: n <= 1),
  1 = (F n).
Proof.
intuition.
assert (h : n = 0 \/ n = 1).
 omega.
intuition; rewrite H; auto with *.
Qed.

(* Why obligation from file "fib.mlw", characters 849-867 *)
Lemma fib2_po_2 : 
  forall (n: Z),
  forall (Pre4: n >= 0),
  forall (Test1: n > 1),
  (1 <= 1 /\ 1 <= n) /\ 1 = (F 1) /\ 1 = (F (1 - 1)).
Proof.
intuition.
Qed.


(* Why obligation from file "fib.mlw", characters 1144-1210 *)
Lemma fib3_po_1 : 
  forall (n: Z),
  forall (Pre4: n >= 0),
  forall (k: Z),
  forall (Post8: k = 1),
  forall (x: Z),
  forall (Post7: x = 1),
  forall (y: Z),
  forall (Post6: y = 1),
  forall (Test4: n > 0),
  forall (Variant1: Z),
  forall (k1: Z),
  forall (x1: Z),
  forall (y1: Z),
  forall (Pre3: Variant1 = (n - k1)),
  forall (Pre2: (1 <= k1 /\ k1 <= n) /\ x1 = (F k1) /\ y1 = (F (k1 - 1))),
  forall (Test3: k1 < n),
  forall (t: Z),
  forall (Post4: t = y1),
  forall (y2: Z),
  forall (Post1: y2 = x1),
  forall (x2: Z),
  forall (Post2: x2 = (x1 + t)),
  forall (k2: Z),
  forall (Post3: k2 = (k1 + 1)),
  ((1 <= k2 /\ k2 <= n) /\ x2 = (F k2) /\ y2 = (F (k2 - 1))) /\
  (Zwf 0 (n - k2) (n - k1)).
Proof.
intuition.
subst k2; subst x2; subst t.
subst x1 y1.
symmetry.
generalize H1.
 replace k1 with (k1 + 1 - 1)%Z.
 generalize (k1 + 1)%Z.
intros; ring (z - 1 + 1)%Z; replace (z - 1 - 1)%Z with (z - 2)%Z.
 auto with *.
omega.
omega.
subst k2; ring (k1 + 1 - 1)%Z; trivial.
subst y2; assumption.
Qed.

(* Why obligation from file "fib.mlw", characters 1061-1100 *)
Lemma fib3_po_2 : 
  forall (n: Z),
  forall (Pre4: n >= 0),
  forall (k: Z),
  forall (Post8: k = 1),
  forall (x: Z),
  forall (Post7: x = 1),
  forall (y: Z),
  forall (Post6: y = 1),
  forall (Test4: n > 0),
  (1 <= k /\ k <= n) /\ x = (F k) /\ y = (F (k - 1)).
Proof.
intuition; subst; auto with *.
Qed.

(* Why obligation from file "fib.mlw", characters 1027-1219 *)
Lemma fib3_po_3 : 
  forall (n: Z),
  forall (Pre4: n >= 0),
  forall (k: Z),
  forall (Post8: k = 1),
  forall (x: Z),
  forall (Post7: x = 1),
  forall (y: Z),
  forall (Post6: y = 1),
  forall (Test4: n > 0),
  forall (k1: Z),
  forall (x1: Z),
  forall (y1: Z),
  forall (Post5: ((1 <= k1 /\ k1 <= n) /\ x1 = (F k1) /\ y1 =
                 (F (k1 - 1))) /\ k1 >= n),
  x1 = (F n).
Proof.
intuition.
replace n with k1.
 auto.
 omega.
Qed.

(* Why obligation from file "fib.mlw", characters 1219-1219 *)
Lemma fib3_po_4 : 
  forall (n: Z),
  forall (Pre4: n >= 0),
  forall (k: Z),
  forall (Post8: k = 1),
  forall (x: Z),
  forall (Post7: x = 1),
  forall (y: Z),
  forall (Post6: y = 1),
  forall (Test1: n <= 0),
  x = (F n).
Proof.
intuition.
subst x.
 replace n with 0%Z.
 auto.
omega.
Qed.



(* Why obligation from file "fib.mlw", characters 1393-1394 *)
Lemma fib4_po_1 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test4: n <= 1),
  1 = (F n).
Proof.
intros.
assert (h: n = 0 \/ n = 1).
 omega.
intuition; rewrite H1; auto.
Qed.

(* Why obligation from file "fib.mlw", characters 1414-1423 *)
Lemma fib4_po_2 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  0 <= 0 /\ 0 < (array_length t).
Proof.
intros; simpl; omega.
Qed.

(* Why obligation from file "fib.mlw", characters 1430-1439 *)
Lemma fib4_po_3 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  0 <= 1 /\ 1 < (array_length t0).
Proof.
intros; subst t0; simpl; omega.
Qed.

(* Why obligation from file "fib.mlw", characters 1653-1683 *)
Lemma fib4_po_4 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  forall (Pre8: 0 <= 1 /\ 1 < (array_length t0)),
  forall (t1: (array Z)),
  forall (Post2: t1 = (store t0 1 1)),
  forall (k: Z),
  forall (Post6: k = 2),
  forall (Variant1: Z),
  forall (k1: Z),
  forall (t2: (array Z)),
  forall (Pre6: Variant1 = (n + 1 - k1)),
  forall (Pre5: (2 <= k1 /\ k1 <= (n + 1)) /\ (array_length t2) =
                (array_length t) /\
                (forall (i:Z), (0 <= i /\ i < k1 -> (access t2 i) = (F i)))),
  forall (Test2: k1 <= n),
  0 <= k1 /\ k1 < (array_length t2).
Proof.
simpl; intuition.
Qed.

(* Why obligation from file "fib.mlw", characters 1674-1683 *)
Lemma fib4_po_5 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  forall (Pre8: 0 <= 1 /\ 1 < (array_length t0)),
  forall (t1: (array Z)),
  forall (Post2: t1 = (store t0 1 1)),
  forall (k: Z),
  forall (Post6: k = 2),
  forall (Variant1: Z),
  forall (k1: Z),
  forall (t2: (array Z)),
  forall (Pre6: Variant1 = (n + 1 - k1)),
  forall (Pre5: (2 <= k1 /\ k1 <= (n + 1)) /\ (array_length t2) =
                (array_length t) /\
                (forall (i:Z), (0 <= i /\ i < k1 -> (access t2 i) = (F i)))),
  forall (Test2: k1 <= n),
  forall (Pre2: 0 <= k1 /\ k1 < (array_length t2)),
  0 <= (k1 - 2) /\ (k1 - 2) < (array_length t2).
Proof.
intuition.
Qed.

(* Why obligation from file "fib.mlw", characters 1662-1671 *)
Lemma fib4_po_6 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  forall (Pre8: 0 <= 1 /\ 1 < (array_length t0)),
  forall (t1: (array Z)),
  forall (Post2: t1 = (store t0 1 1)),
  forall (k: Z),
  forall (Post6: k = 2),
  forall (Variant1: Z),
  forall (k1: Z),
  forall (t2: (array Z)),
  forall (Pre6: Variant1 = (n + 1 - k1)),
  forall (Pre5: (2 <= k1 /\ k1 <= (n + 1)) /\ (array_length t2) =
                (array_length t) /\
                (forall (i:Z), (0 <= i /\ i < k1 -> (access t2 i) = (F i)))),
  forall (Test2: k1 <= n),
  forall (Pre2: 0 <= k1 /\ k1 < (array_length t2)),
  forall (Pre3: 0 <= (k1 - 2) /\ (k1 - 2) < (array_length t2)),
  0 <= (k1 - 1) /\ (k1 - 1) < (array_length t2).
Proof.
intuition.
Qed.

(* Why obligation from file "fib.mlw", characters 1653-1703 *)
Lemma fib4_po_7 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  forall (Pre8: 0 <= 1 /\ 1 < (array_length t0)),
  forall (t1: (array Z)),
  forall (Post2: t1 = (store t0 1 1)),
  forall (k: Z),
  forall (Post6: k = 2),
  forall (Variant1: Z),
  forall (k1: Z),
  forall (t2: (array Z)),
  forall (Pre6: Variant1 = (n + 1 - k1)),
  forall (Pre5: (2 <= k1 /\ k1 <= (n + 1)) /\ (array_length t2) =
                (array_length t) /\
                (forall (i:Z), (0 <= i /\ i < k1 -> (access t2 i) = (F i)))),
  forall (Test2: k1 <= n),
  forall (Pre2: 0 <= k1 /\ k1 < (array_length t2)),
  forall (Pre3: 0 <= (k1 - 2) /\ (k1 - 2) < (array_length t2)),
  forall (Pre4: 0 <= (k1 - 1) /\ (k1 - 1) < (array_length t2)),
  forall (t3: (array Z)),
  forall (Post3: t3 = (store t2 k1
                       ((access t2 (k1 - 1)) + (access t2 (k1 - 2))))),
  forall (k2: Z),
  forall (Post4: k2 = (k1 + 1)),
  ((2 <= k2 /\ k2 <= (n + 1)) /\ (array_length t3) = (array_length t) /\
  (forall (i:Z), (0 <= i /\ i < k2 -> (access t3 i) = (F i)))) /\
  (Zwf 0 (n + 1 - k2) (n + 1 - k1)).
Proof.
intuition.
subst t3; auto.
subst t3.
assert (hi: i = k1 \/ (i < k1)).
 omega.
intuition.
subst i.
  AccessSame.
rewrite (H15 (k1 - 1)%Z).
 rewrite (H15 (k1 - 2)%Z).
 symmetry; auto with *.
omega.
omega.
AccessOther.
auto.
Qed.


(* Why obligation from file "fib.mlw", characters 1504-1616 *)
Lemma fib4_po_8 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  forall (Pre8: 0 <= 1 /\ 1 < (array_length t0)),
  forall (t1: (array Z)),
  forall (Post2: t1 = (store t0 1 1)),
  forall (k: Z),
  forall (Post6: k = 2),
  (2 <= k /\ k <= (n + 1)) /\ (array_length t1) = (array_length t) /\
  (forall (i:Z), (0 <= i /\ i < k -> (access t1 i) = (F i))).
Proof.
intuition.
subst t1 t0; auto.
assert (hi: i = 0 \/ i = 1).
 omega.
 intuition.
subst i t1; AccessOther.
subst t0; AccessSame.
 auto.
subst i t1; AccessSame.
 auto.
Qed.

(* Why obligation from file "fib.mlw", characters 1446-1713 *)
Lemma fib4_po_9 : 
  forall (n: Z),
  forall (t: (array Z)),
  forall (Pre10: 0 <= n /\ n < (array_length t)),
  forall (Test3: n > 1),
  forall (Pre9: 0 <= 0 /\ 0 < (array_length t)),
  forall (t0: (array Z)),
  forall (Post1: t0 = (store t 0 1)),
  forall (Pre8: 0 <= 1 /\ 1 < (array_length t0)),
  forall (t1: (array Z)),
  forall (Post2: t1 = (store t0 1 1)),
  forall (k: Z),
  forall (Post6: k = 2),
  forall (k1: Z),
  forall (t2: (array Z)),
  forall (Post5: ((2 <= k1 /\ k1 <= (n + 1)) /\ (array_length t2) =
                 (array_length t) /\
                 (forall (i:Z), (0 <= i /\ i < k1 -> (access t2 i) = (F i)))) /\
                 k1 > n),
  (access t2 n) = (F n) /\ 0 <= n /\ n < (array_length t2).
Proof.
intuition.
Qed.

